#include "tag.h"

#include "json/layout.h"

#include <stdlib.h>
#include <string.h>
#include <stddef.h>

static struct json_enum ap_activity_tag_enum[] = {
	{ "Mention", aptag_mention },
	{ NULL, 0 },
};

static struct json_object_field ap_activity_tag_layout[] = {
	{ "type",			offsetof( struct ap_activity_tag, type ),			true,  &json_field_enum, ap_activity_tag_enum },
	{ "href",			offsetof( struct ap_activity_tag, href ),			false, &json_field_string },
	{ "name",			offsetof( struct ap_activity_tag, name ),			false, &json_field_string },
	{ NULL },
};

void ap_activity_tag_free( struct ap_activity_tag* tag )
{
	if( !tag ) { return; }

	free(tag->href);
	free(tag->name);
	memset(tag,0,sizeof(*tag));
	free(tag);
}

static void* alloc()
{
	struct ap_activity_tag* ptr = malloc(sizeof(struct ap_activity_tag));
	memset(ptr,0,sizeof(*ptr));
	return ptr;
}
static void free_shim( void* ptr )
{
	ap_activity_tag_free(ptr);
}

struct json_field_type ap_activity_tag_type = {
	.reader = json_field_object_type_reader,
	.writer = json_field_object_type_writer,
	.size = sizeof( struct ap_activity_tag ),
	.layout = ap_activity_tag_layout,
	.alloc = alloc,
	.free = free_shim,
};

